#include <cstring>

namespace emilua::gperf::detail { using std::size_t; using std::strcmp; }


#include <emilua/file_descriptor.hpp>

#include <charconv>

#include <boost/hana/integral_constant.hpp>
#include <boost/hana/greater.hpp>
#include <boost/hana/string.hpp>
#include <boost/hana/plus.hpp>
#include <boost/hana/div.hpp>

#include <boost/scope_exit.hpp>

#if BOOST_OS_LINUX
#include <sys/capability.h>
#include <emilua/system.hpp>
#endif // BOOST_OS_LINUX

#if BOOST_OS_BSD_FREE
#include <sys/capsicum.h>

#define EMILUA_DETAIL_CAP_CONSTANT(X)      \
    ([]() -> cap_rights_t {                \
        cap_rights_t flag;                 \
        cap_rights_init(&flag, CAP_ ## X); \
        return flag;                       \
    }())
#endif // BOOST_OS_BSD_FREE
#if BOOST_OS_BSD_FREE
namespace emilua::gperf::detail {
/* C++ code produced by gperf version 3.1 */
/* Command-line: /usr/bin/gperf --language=C++ --enum --readonly-tables --struct-type --initializer-suffix=',{}' --class-name=gperf__src_file_descriptor_cpp_1  */
/* Computed positions: -k'1,5-6,13,$' */

#if !((' ' == 32) && ('!' == 33) && ('"' == 34) && ('#' == 35) \
      && ('%' == 37) && ('&' == 38) && ('\'' == 39) && ('(' == 40) \
      && (')' == 41) && ('*' == 42) && ('+' == 43) && (',' == 44) \
      && ('-' == 45) && ('.' == 46) && ('/' == 47) && ('0' == 48) \
      && ('1' == 49) && ('2' == 50) && ('3' == 51) && ('4' == 52) \
      && ('5' == 53) && ('6' == 54) && ('7' == 55) && ('8' == 56) \
      && ('9' == 57) && (':' == 58) && (';' == 59) && ('<' == 60) \
      && ('=' == 61) && ('>' == 62) && ('?' == 63) && ('A' == 65) \
      && ('B' == 66) && ('C' == 67) && ('D' == 68) && ('E' == 69) \
      && ('F' == 70) && ('G' == 71) && ('H' == 72) && ('I' == 73) \
      && ('J' == 74) && ('K' == 75) && ('L' == 76) && ('M' == 77) \
      && ('N' == 78) && ('O' == 79) && ('P' == 80) && ('Q' == 81) \
      && ('R' == 82) && ('S' == 83) && ('T' == 84) && ('U' == 85) \
      && ('V' == 86) && ('W' == 87) && ('X' == 88) && ('Y' == 89) \
      && ('Z' == 90) && ('[' == 91) && ('\\' == 92) && (']' == 93) \
      && ('^' == 94) && ('_' == 95) && ('a' == 97) && ('b' == 98) \
      && ('c' == 99) && ('d' == 100) && ('e' == 101) && ('f' == 102) \
      && ('g' == 103) && ('h' == 104) && ('i' == 105) && ('j' == 106) \
      && ('k' == 107) && ('l' == 108) && ('m' == 109) && ('n' == 110) \
      && ('o' == 111) && ('p' == 112) && ('q' == 113) && ('r' == 114) \
      && ('s' == 115) && ('t' == 116) && ('u' == 117) && ('v' == 118) \
      && ('w' == 119) && ('x' == 120) && ('y' == 121) && ('z' == 122) \
      && ('{' == 123) && ('|' == 124) && ('}' == 125) && ('~' == 126))
/* The character set is not based on ISO-646.  */
#error "gperf generated tables don't work with this execution character set. Please report a bug to <bug-gperf@gnu.org>."
#endif

struct word_type_gperf__src_file_descriptor_cpp_1 { const char* name; cap_rights_t action; };
/* maximum key range = 180, duplicates = 0 */

class gperf__src_file_descriptor_cpp_1
{
private:
  static inline unsigned int hash (const char *str, size_t len);
public:
  static const struct word_type_gperf__src_file_descriptor_cpp_1 *in_word_set (const char *str, size_t len);
};

inline unsigned int
gperf__src_file_descriptor_cpp_1::hash (const char *str, size_t len)
{
  static const unsigned char asso_values[] =
    {
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184,   0, 184,  25,   0,   0,
        0,   0,  15,  45,  25,  35, 184,  40,  20,  60,
       25,   5,   5, 184,  35,  30,   5, 105,   5,  50,
       25, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
      184, 184, 184, 184, 184, 184
    };
  unsigned int hval = len;

  switch (hval)
    {
      default:
        hval += asso_values[static_cast<unsigned char>(str[12])];
      /*FALLTHROUGH*/
      case 12:
      case 11:
      case 10:
      case 9:
      case 8:
      case 7:
      case 6:
        hval += asso_values[static_cast<unsigned char>(str[5])];
      /*FALLTHROUGH*/
      case 5:
        hval += asso_values[static_cast<unsigned char>(str[4])];
      /*FALLTHROUGH*/
      case 4:
      case 3:
      case 2:
      case 1:
        hval += asso_values[static_cast<unsigned char>(str[0])];
        break;
    }
  return hval + asso_values[static_cast<unsigned char>(str[len - 1])];
}

const struct word_type_gperf__src_file_descriptor_cpp_1 *
gperf__src_file_descriptor_cpp_1::in_word_set (const char *str, size_t len)
{
  enum
    {
      TOTAL_KEYWORDS = 78,
      MIN_WORD_LENGTH = 4,
      MAX_WORD_LENGTH = 16,
      MIN_HASH_VALUE = 4,
      MAX_HASH_VALUE = 183
    };

  static const struct word_type_gperf__src_file_descriptor_cpp_1 wordlist[] =
    {
      {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"bind",  EMILUA_DETAIL_CAP_CONSTANT(BIND)},
      {"",{}}, {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"pread",  EMILUA_DETAIL_CAP_CONSTANT(PREAD)},
      {"create",  EMILUA_DETAIL_CAP_CONSTANT(CREATE)},
      {"connect",  EMILUA_DETAIL_CAP_CONSTANT(CONNECT)},
      {"",{}},
      {"connectat",  EMILUA_DETAIL_CAP_CONSTANT(CONNECTAT)},
      {"event",  EMILUA_DETAIL_CAP_CONSTANT(EVENT)},
      {"pwrite",  EMILUA_DETAIL_CAP_CONSTANT(PWRITE)},
      {"",{}}, {"",{}}, {"",{}},
      {"fsync",  EMILUA_DETAIL_CAP_CONSTANT(FSYNC)},
      {"",{}}, {"",{}},
      {"pdgetpid",  EMILUA_DETAIL_CAP_CONSTANT(PDGETPID)},
      {"",{}}, {"",{}},
      {"fchmod",  EMILUA_DETAIL_CAP_CONSTANT(FCHMOD)},
      {"fexecve",  EMILUA_DETAIL_CAP_CONSTANT(FEXECVE)},
      {"",{}},
      {"extattr_delete",  EMILUA_DETAIL_CAP_CONSTANT(EXTATTR_DELETE)},
      {"fstat",  EMILUA_DETAIL_CAP_CONSTANT(FSTAT)},
      {"",{}}, {"",{}},
      {"fchmodat",  EMILUA_DETAIL_CAP_CONSTANT(FCHMODAT)},
      {"send",  EMILUA_DETAIL_CAP_CONSTANT(SEND)},
      {"acl_delete",  EMILUA_DETAIL_CAP_CONSTANT(ACL_DELETE)},
      {"",{}}, {"",{}}, {"",{}},
      {"read",  EMILUA_DETAIL_CAP_CONSTANT(READ)},
      {"",{}},
      {"bindat",  EMILUA_DETAIL_CAP_CONSTANT(BINDAT)},
      {"",{}}, {"",{}},
      {"recv",  EMILUA_DETAIL_CAP_CONSTANT(RECV)},
      {"",{}},
      {"accept",  EMILUA_DETAIL_CAP_CONSTANT(ACCEPT)},
      {"peeloff",  EMILUA_DETAIL_CAP_CONSTANT(PEELOFF)},
      {"",{}},
      {"ftruncate",  EMILUA_DETAIL_CAP_CONSTANT(FTRUNCATE)},
      {"setsockopt",  EMILUA_DETAIL_CAP_CONSTANT(SETSOCKOPT)},
      {"",{}}, {"",{}},
      {"sem_post",  EMILUA_DETAIL_CAP_CONSTANT(SEM_POST)},
      {"",{}},
      {"write",  EMILUA_DETAIL_CAP_CONSTANT(WRITE)},
      {"getpeername",  EMILUA_DETAIL_CAP_CONSTANT(GETPEERNAME)},
      {"fstatat",  EMILUA_DETAIL_CAP_CONSTANT(FSTATAT)},
      {"",{}},
      {"fsck",  EMILUA_DETAIL_CAP_CONSTANT(FSCK)},
      {"fcntl",  EMILUA_DETAIL_CAP_CONSTANT(FCNTL)},
      {"getsockname",  EMILUA_DETAIL_CAP_CONSTANT(GETSOCKNAME)},
      {"ttyhook",  EMILUA_DETAIL_CAP_CONSTANT(TTYHOOK)},
      {"linkat_source",  EMILUA_DETAIL_CAP_CONSTANT(LINKAT_SOURCE)},
      {"fpathconf",  EMILUA_DETAIL_CAP_CONSTANT(FPATHCONF)},
      {"getsockopt",  EMILUA_DETAIL_CAP_CONSTANT(GETSOCKOPT)},
      {"cap_extattr_list",  EMILUA_DETAIL_CAP_CONSTANT(EXTATTR_LIST)},
      {"acl_set",  EMILUA_DETAIL_CAP_CONSTANT(ACL_SET)},
      {"shutdown",  EMILUA_DETAIL_CAP_CONSTANT(SHUTDOWN)},
      {"mmap",  EMILUA_DETAIL_CAP_CONSTANT(MMAP)},
      {"",{}},
      {"pdkill",  EMILUA_DETAIL_CAP_CONSTANT(PDKILL)},
      {"fstatfs",  EMILUA_DETAIL_CAP_CONSTANT(FSTATFS)},
      {"linkat_target",  EMILUA_DETAIL_CAP_CONSTANT(LINKAT_TARGET)},
      {"seek",  EMILUA_DETAIL_CAP_CONSTANT(SEEK)},
      {"cap_extattr_set",  EMILUA_DETAIL_CAP_CONSTANT(EXTATTR_SET)},
      {"listen",  EMILUA_DETAIL_CAP_CONSTANT(LISTEN)},
      {"",{}}, {"",{}}, {"",{}},
      {"ioctl",  EMILUA_DETAIL_CAP_CONSTANT(IOCTL)},
      {"",{}},
      {"acl_get",  EMILUA_DETAIL_CAP_CONSTANT(ACL_GET)},
      {"",{}},
      {"chflagsat",  EMILUA_DETAIL_CAP_CONSTANT(CHFLAGSAT)},
      {"",{}}, {"",{}},
      {"sem_getvalue",  EMILUA_DETAIL_CAP_CONSTANT(SEM_GETVALUE)},
      {"",{}},
      {"futimesat",  EMILUA_DETAIL_CAP_CONSTANT(FUTIMESAT)},
      {"cap_extattr_get",  EMILUA_DETAIL_CAP_CONSTANT(EXTATTR_GET)},
      {"",{}}, {"",{}},
      {"mkfifoat",  EMILUA_DETAIL_CAP_CONSTANT(MKFIFOAT)},
      {"",{}}, {"",{}}, {"",{}},
      {"mknodat",  EMILUA_DETAIL_CAP_CONSTANT(MKNODAT)},
      {"fchflags",  EMILUA_DETAIL_CAP_CONSTANT(FCHFLAGS)},
      {"acl_check",  EMILUA_DETAIL_CAP_CONSTANT(ACL_CHECK)},
      {"flock",  EMILUA_DETAIL_CAP_CONSTANT(FLOCK)},
      {"",{}},
      {"mac_set",  EMILUA_DETAIL_CAP_CONSTANT(MAC_SET)},
      {"fchownat",  EMILUA_DETAIL_CAP_CONSTANT(FCHOWNAT)},
      {"symlinkat",  EMILUA_DETAIL_CAP_CONSTANT(SYMLINKAT)},
      {"",{}}, {"",{}}, {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"",{}},
      {"futimes",  EMILUA_DETAIL_CAP_CONSTANT(FUTIMES)},
      {"",{}}, {"",{}}, {"",{}},
      {"mmap_x",  EMILUA_DETAIL_CAP_CONSTANT(MMAP_X)},
      {"mac_get",  EMILUA_DETAIL_CAP_CONSTANT(MAC_GET)},
      {"sem_wait",  EMILUA_DETAIL_CAP_CONSTANT(SEM_WAIT)},
      {"",{}}, {"",{}},
      {"fchown",  EMILUA_DETAIL_CAP_CONSTANT(FCHOWN)},
      {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"fchdir",  EMILUA_DETAIL_CAP_CONSTANT(FCHDIR)},
      {"mmap_rx",  EMILUA_DETAIL_CAP_CONSTANT(MMAP_RX)},
      {"mmap_rwx",  EMILUA_DETAIL_CAP_CONSTANT(MMAP_RWX)},
      {"",{}}, {"",{}}, {"",{}},
      {"mkdirat",  EMILUA_DETAIL_CAP_CONSTANT(MKDIRAT)},
      {"",{}}, {"",{}}, {"",{}},
      {"mmap_r",  EMILUA_DETAIL_CAP_CONSTANT(MMAP_R)},
      {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"lookup",  EMILUA_DETAIL_CAP_CONSTANT(LOOKUP)},
      {"mmap_wx",  EMILUA_DETAIL_CAP_CONSTANT(MMAP_WX)},
      {"",{}}, {"",{}},
      {"renameat_source",  EMILUA_DETAIL_CAP_CONSTANT(RENAMEAT_SOURCE)},
      {"",{}}, {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"kqueue",  EMILUA_DETAIL_CAP_CONSTANT(KQUEUE)},
      {"mmap_rw",  EMILUA_DETAIL_CAP_CONSTANT(MMAP_RW)},
      {"",{}}, {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"kqueue_change",  EMILUA_DETAIL_CAP_CONSTANT(KQUEUE_CHANGE)},
      {"",{}},
      {"renameat_target",  EMILUA_DETAIL_CAP_CONSTANT(RENAMEAT_TARGET)},
      {"",{}},
      {"kqueue_event",  EMILUA_DETAIL_CAP_CONSTANT(KQUEUE_EVENT)},
      {"",{}}, {"",{}}, {"",{}},
      {"mmap_w",  EMILUA_DETAIL_CAP_CONSTANT(MMAP_W)},
      {"",{}}, {"",{}}, {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"",{}}, {"",{}}, {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"unlinkat",  EMILUA_DETAIL_CAP_CONSTANT(UNLINKAT)}
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      unsigned int key = hash (str, len);

      if (key <= MAX_HASH_VALUE)
        {
          const char *s = wordlist[key].name;

          if (*str == *s && !strcmp (str + 1, s + 1))
            return &wordlist[key];
        }
    }
  return 0;
}

} // namespace emilua::gperf::detail
#endif // BOOST_OS_BSD_FREE
#if BOOST_OS_BSD_FREE
namespace emilua::gperf::detail {
/* C++ code produced by gperf version 3.1 */
/* Command-line: /usr/bin/gperf --language=C++ --enum --readonly-tables --struct-type --initializer-suffix=',{}' --class-name=gperf__src_file_descriptor_cpp_2  */
/* Computed positions: -k'1' */

#if !((' ' == 32) && ('!' == 33) && ('"' == 34) && ('#' == 35) \
      && ('%' == 37) && ('&' == 38) && ('\'' == 39) && ('(' == 40) \
      && (')' == 41) && ('*' == 42) && ('+' == 43) && (',' == 44) \
      && ('-' == 45) && ('.' == 46) && ('/' == 47) && ('0' == 48) \
      && ('1' == 49) && ('2' == 50) && ('3' == 51) && ('4' == 52) \
      && ('5' == 53) && ('6' == 54) && ('7' == 55) && ('8' == 56) \
      && ('9' == 57) && (':' == 58) && (';' == 59) && ('<' == 60) \
      && ('=' == 61) && ('>' == 62) && ('?' == 63) && ('A' == 65) \
      && ('B' == 66) && ('C' == 67) && ('D' == 68) && ('E' == 69) \
      && ('F' == 70) && ('G' == 71) && ('H' == 72) && ('I' == 73) \
      && ('J' == 74) && ('K' == 75) && ('L' == 76) && ('M' == 77) \
      && ('N' == 78) && ('O' == 79) && ('P' == 80) && ('Q' == 81) \
      && ('R' == 82) && ('S' == 83) && ('T' == 84) && ('U' == 85) \
      && ('V' == 86) && ('W' == 87) && ('X' == 88) && ('Y' == 89) \
      && ('Z' == 90) && ('[' == 91) && ('\\' == 92) && (']' == 93) \
      && ('^' == 94) && ('_' == 95) && ('a' == 97) && ('b' == 98) \
      && ('c' == 99) && ('d' == 100) && ('e' == 101) && ('f' == 102) \
      && ('g' == 103) && ('h' == 104) && ('i' == 105) && ('j' == 106) \
      && ('k' == 107) && ('l' == 108) && ('m' == 109) && ('n' == 110) \
      && ('o' == 111) && ('p' == 112) && ('q' == 113) && ('r' == 114) \
      && ('s' == 115) && ('t' == 116) && ('u' == 117) && ('v' == 118) \
      && ('w' == 119) && ('x' == 120) && ('y' == 121) && ('z' == 122) \
      && ('{' == 123) && ('|' == 124) && ('}' == 125) && ('~' == 126))
/* The character set is not based on ISO-646.  */
#error "gperf generated tables don't work with this execution character set. Please report a bug to <bug-gperf@gnu.org>."
#endif

struct word_type_gperf__src_file_descriptor_cpp_2 { const char* name; std::uint32_t action; };
/* maximum key range = 7, duplicates = 0 */

class gperf__src_file_descriptor_cpp_2
{
private:
  static inline unsigned int hash (const char *str, size_t len);
public:
  static const struct word_type_gperf__src_file_descriptor_cpp_2 *in_word_set (const char *str, size_t len);
};

inline unsigned int
gperf__src_file_descriptor_cpp_2::hash (const char *str, size_t len)
{
  static const unsigned char asso_values[] =
    {
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12,  5, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12,  0, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
      12, 12, 12, 12, 12, 12
    };
  return len + asso_values[static_cast<unsigned char>(str[0])];
}

const struct word_type_gperf__src_file_descriptor_cpp_2 *
gperf__src_file_descriptor_cpp_2::in_word_set (const char *str, size_t len)
{
  enum
    {
      TOTAL_KEYWORDS = 4,
      MIN_WORD_LENGTH = 5,
      MAX_WORD_LENGTH = 6,
      MIN_HASH_VALUE = 5,
      MAX_HASH_VALUE = 11
    };

  static const struct word_type_gperf__src_file_descriptor_cpp_2 wordlist[] =
    {
      {"",{}}, {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"setfl",  CAP_FCNTL_SETFL},
      {"setown",  CAP_FCNTL_SETOWN},
      {"",{}}, {"",{}}, {"",{}},
      {"getfl",  CAP_FCNTL_GETFL},
      {"getown",  CAP_FCNTL_GETOWN}
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      unsigned int key = hash (str, len);

      if (key <= MAX_HASH_VALUE)
        {
          const char *s = wordlist[key].name;

          if (*str == *s && !strcmp (str + 1, s + 1))
            return &wordlist[key];
        }
    }
  return 0;
}

} // namespace emilua::gperf::detail
#endif // BOOST_OS_BSD_FREE
namespace emilua {



static char closed_file_descriptor_mt_key;

#if BOOST_OS_BSD_FREE
static const cap_rights_t empty_rights = []() {
    cap_rights_t ret;
    cap_rights_init(&ret);
    return ret;
}();
#endif // BOOST_OS_BSD_FREE

static int file_descriptor_close(lua_State* L)
{
    auto handle = static_cast<file_descriptor_handle*>(lua_touserdata(L, 1));
    if (!handle || !lua_getmetatable(L, 1)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }
    rawgetp(L, LUA_REGISTRYINDEX, &file_descriptor_mt_key);
    if (!lua_rawequal(L, -1, -2)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }

    if (*handle == INVALID_FILE_DESCRIPTOR) {
        push(L, std::errc::device_or_resource_busy);
        return lua_error(L);
    }

    rawgetp(L, LUA_REGISTRYINDEX, &closed_file_descriptor_mt_key);
    setmetatable(L, 1);

#if BOOST_OS_WINDOWS
    BOOL res = CloseHandle(*handle);
#else // BOOST_OS_WINDOWS
    int res = close(*handle);
#endif // BOOST_OS_WINDOWS
    boost::ignore_unused(res);

    return 0;
}

static int file_descriptor_dup(lua_State* L)
{
    auto oldhandle = static_cast<file_descriptor_handle*>(lua_touserdata(L, 1));
    if (!oldhandle || !lua_getmetatable(L, 1)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }
    rawgetp(L, LUA_REGISTRYINDEX, &file_descriptor_mt_key);
    if (!lua_rawequal(L, -1, -2)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }

    if (*oldhandle == INVALID_FILE_DESCRIPTOR) {
        push(L, std::errc::device_or_resource_busy);
        return lua_error(L);
    }

#if BOOST_OS_WINDOWS
    return throw_enosys(L);
#else // BOOST_OS_WINDOWS
    int newfd = dup(*oldhandle);
    BOOST_SCOPE_EXIT_ALL(&) {
        if (newfd != -1) {
            int res = close(newfd);
            boost::ignore_unused(res);
        }
    };
    if (newfd == -1) {
        push(L, std::error_code{errno, std::system_category()});
        return lua_error(L);
    }

    auto newhandle = static_cast<file_descriptor_handle*>(
        lua_newuserdata(L, sizeof(file_descriptor_handle))
    );
    rawgetp(L, LUA_REGISTRYINDEX, &file_descriptor_mt_key);
    setmetatable(L, -2);

    *newhandle = newfd;
    newfd = -1;
    return 1;
#endif // BOOST_OS_WINDOWS
}

inline int file_descriptor_non_blocking_get(lua_State* L)
{
    auto handle = static_cast<file_descriptor_handle*>(lua_touserdata(L, 1));
    if (*handle == INVALID_FILE_DESCRIPTOR) {
        push(L, std::errc::device_or_resource_busy);
        return lua_error(L);
    }

#if BOOST_OS_WINDOWS
    return throw_enosys(L);
#else // BOOST_OS_WINDOWS
    int f = fcntl(*handle, F_GETFL, 0);

    // although not always documented, F_GETFL can fail
    if (f == -1) {
        push(L, std::error_code{errno, std::system_category()});
        return lua_error(L);
    }

    lua_pushboolean(L, (f & O_NONBLOCK) == O_NONBLOCK);
    return 1;
#endif // BOOST_OS_WINDOWS
}

#if BOOST_OS_LINUX
static int file_descriptor_cap_get(lua_State* L)
{
    auto handle = static_cast<file_descriptor_handle*>(lua_touserdata(L, 1));
    if (!handle || !lua_getmetatable(L, 1)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }
    rawgetp(L, LUA_REGISTRYINDEX, &file_descriptor_mt_key);
    if (!lua_rawequal(L, -1, -2)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }

    if (*handle == INVALID_FILE_DESCRIPTOR) {
        push(L, std::errc::device_or_resource_busy);
        return lua_error(L);
    }

    cap_t caps = cap_get_fd(*handle);
    if (caps == NULL) {
        push(L, std::error_code{errno, std::system_category()});
        return lua_error(L);
    }
    BOOST_SCOPE_EXIT_ALL(&) {
        if (caps != NULL)
            cap_free(caps);
    };

    auto& caps2 = *static_cast<cap_t*>(lua_newuserdata(L, sizeof(cap_t)));
    rawgetp(L, LUA_REGISTRYINDEX, &linux_capabilities_mt_key);
    setmetatable(L, -2);
    caps2 = caps;
    caps = NULL;

    return 1;
}

static int file_descriptor_cap_set(lua_State* L)
{
    auto handle = static_cast<file_descriptor_handle*>(lua_touserdata(L, 1));
    if (!handle || !lua_getmetatable(L, 1)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }
    rawgetp(L, LUA_REGISTRYINDEX, &file_descriptor_mt_key);
    if (!lua_rawequal(L, -1, -2)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }

    if (*handle == INVALID_FILE_DESCRIPTOR) {
        push(L, std::errc::device_or_resource_busy);
        return lua_error(L);
    }

    auto caps = static_cast<cap_t*>(lua_touserdata(L, 2));
    if (!caps || !lua_getmetatable(L, 2)) {
        push(L, std::errc::invalid_argument, "arg", 2);
        return lua_error(L);
    }
    rawgetp(L, LUA_REGISTRYINDEX, &linux_capabilities_mt_key);
    if (!lua_rawequal(L, -1, -2)) {
        push(L, std::errc::invalid_argument, "arg", 2);
        return lua_error(L);
    }

    if (cap_set_fd(*handle, *caps) == -1) {
        push(L, std::error_code{errno, std::system_category()});
        return lua_error(L);
    }
    return 0;
}
#endif // BOOST_OS_LINUX

#if BOOST_OS_BSD_FREE
static int file_descriptor_cap_rights_limit(lua_State* L)
{
    lua_settop(L, 2);

    auto handle = static_cast<file_descriptor_handle*>(lua_touserdata(L, 1));
    if (!handle || !lua_getmetatable(L, 1)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }
    rawgetp(L, LUA_REGISTRYINDEX, &file_descriptor_mt_key);
    if (!lua_rawequal(L, -1, -2)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }

    if (*handle == INVALID_FILE_DESCRIPTOR) {
        push(L, std::errc::device_or_resource_busy);
        return lua_error(L);
    }

    luaL_checktype(L, 2, LUA_TTABLE);

    cap_rights_t rights;
    cap_rights_init(&rights);

    cap_rights_t all_rights;
    cap_rights_init(&all_rights);
    CAP_ALL(&all_rights);

    for (int i = 0 ;; ++i) {
        lua_rawgeti(L, 2, i + 1);
        switch (lua_type(L, -1)) {
        case LUA_TNIL:
            goto input_ready;
        case LUA_TSTRING:
            break;
        default:
            push(L, std::errc::invalid_argument, "arg", 2);
            return lua_error(L);
        }

        auto key = tostringview(L, -1);
        auto flag =  ::emilua::gperf::detail::value_or(::emilua::gperf::detail::gperf__src_file_descriptor_cpp_1::in_word_set((key).data(), (key).size()), empty_rights);

        {
            cap_rights_t complement = all_rights;
            cap_rights_remove(&complement, &flag);
            if (cap_rights_contains(&complement, &all_rights)) {
                push(L, std::errc::invalid_argument, "arg", 2);
                return lua_error(L);
            }
        }

        cap_rights_set(&rights, flag);
        lua_pop(L, 1);
    }

 input_ready:
    if (cap_rights_limit(*handle, &rights) == -1) {
        push(L, std::error_code{errno, std::system_category()});
        return lua_error(L);
    }

    return 0;
}

static int file_descriptor_cap_ioctls_limit(lua_State* L)
{
    lua_settop(L, 2);

    auto handle = static_cast<file_descriptor_handle*>(lua_touserdata(L, 1));
    if (!handle || !lua_getmetatable(L, 1)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }
    rawgetp(L, LUA_REGISTRYINDEX, &file_descriptor_mt_key);
    if (!lua_rawequal(L, -1, -2)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }

    if (*handle == INVALID_FILE_DESCRIPTOR) {
        push(L, std::errc::device_or_resource_busy);
        return lua_error(L);
    }

    luaL_checktype(L, 2, LUA_TTABLE);
    std::vector<unsigned long> cmds;
    for (int i = 0 ;; ++i) {
        lua_rawgeti(L, 2, i + 1);
        switch (lua_type(L, -1)) {
        case LUA_TNIL:
            goto input_ready;
        case LUA_TNUMBER:
            cmds.emplace_back(lua_tointeger(L, -1));
            lua_pop(L, 1);
            break;
        default:
            push(L, std::errc::invalid_argument, "arg", 2);
            return lua_error(L);
        }
    }

 input_ready:
    if (cap_ioctls_limit(*handle, cmds.data(), cmds.size()) == -1) {
        push(L, std::error_code{errno, std::system_category()});
        return lua_error(L);
    }

    return 0;
}

static int file_descriptor_cap_fcntls_limit(lua_State* L)
{
    lua_settop(L, 2);

    auto handle = static_cast<file_descriptor_handle*>(lua_touserdata(L, 1));
    if (!handle || !lua_getmetatable(L, 1)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }
    rawgetp(L, LUA_REGISTRYINDEX, &file_descriptor_mt_key);
    if (!lua_rawequal(L, -1, -2)) {
        push(L, std::errc::invalid_argument, "arg", 1);
        return lua_error(L);
    }

    if (*handle == INVALID_FILE_DESCRIPTOR) {
        push(L, std::errc::device_or_resource_busy);
        return lua_error(L);
    }

    luaL_checktype(L, 2, LUA_TTABLE);
    std::uint32_t fcntlrights = 0;
    for (int i = 0 ;; ++i) {
        lua_rawgeti(L, 2, i + 1);
        switch (lua_type(L, -1)) {
        case LUA_TNIL:
            goto input_ready;
        case LUA_TSTRING:
            break;
        default:
            push(L, std::errc::invalid_argument, "arg", 2);
            return lua_error(L);
        }

        auto key = tostringview(L, -1);
        auto flag =  ::emilua::gperf::detail::value_or(::emilua::gperf::detail::gperf__src_file_descriptor_cpp_2::in_word_set((key).data(), (key).size()), 0);
        if (flag == 0) {
            push(L, std::errc::invalid_argument, "arg", 2);
            return lua_error(L);
        }
        fcntlrights |= flag;
        lua_pop(L, 1);
    }

 input_ready:
    if (cap_fcntls_limit(*handle, fcntlrights) == -1) {
        push(L, std::error_code{errno, std::system_category()});
        return lua_error(L);
    }

    return 0;
}
#endif // BOOST_OS_BSD_FREE

} // namespace emilua
namespace emilua::gperf::detail {
/* C++ code produced by gperf version 3.1 */
/* Command-line: /usr/bin/gperf --language=C++ --enum --readonly-tables --struct-type --initializer-suffix=',{}' --class-name=gperf__src_file_descriptor_cpp_3  */
/* Computed positions: -k'5' */

#if !((' ' == 32) && ('!' == 33) && ('"' == 34) && ('#' == 35) \
      && ('%' == 37) && ('&' == 38) && ('\'' == 39) && ('(' == 40) \
      && (')' == 41) && ('*' == 42) && ('+' == 43) && (',' == 44) \
      && ('-' == 45) && ('.' == 46) && ('/' == 47) && ('0' == 48) \
      && ('1' == 49) && ('2' == 50) && ('3' == 51) && ('4' == 52) \
      && ('5' == 53) && ('6' == 54) && ('7' == 55) && ('8' == 56) \
      && ('9' == 57) && (':' == 58) && (';' == 59) && ('<' == 60) \
      && ('=' == 61) && ('>' == 62) && ('?' == 63) && ('A' == 65) \
      && ('B' == 66) && ('C' == 67) && ('D' == 68) && ('E' == 69) \
      && ('F' == 70) && ('G' == 71) && ('H' == 72) && ('I' == 73) \
      && ('J' == 74) && ('K' == 75) && ('L' == 76) && ('M' == 77) \
      && ('N' == 78) && ('O' == 79) && ('P' == 80) && ('Q' == 81) \
      && ('R' == 82) && ('S' == 83) && ('T' == 84) && ('U' == 85) \
      && ('V' == 86) && ('W' == 87) && ('X' == 88) && ('Y' == 89) \
      && ('Z' == 90) && ('[' == 91) && ('\\' == 92) && (']' == 93) \
      && ('^' == 94) && ('_' == 95) && ('a' == 97) && ('b' == 98) \
      && ('c' == 99) && ('d' == 100) && ('e' == 101) && ('f' == 102) \
      && ('g' == 103) && ('h' == 104) && ('i' == 105) && ('j' == 106) \
      && ('k' == 107) && ('l' == 108) && ('m' == 109) && ('n' == 110) \
      && ('o' == 111) && ('p' == 112) && ('q' == 113) && ('r' == 114) \
      && ('s' == 115) && ('t' == 116) && ('u' == 117) && ('v' == 118) \
      && ('w' == 119) && ('x' == 120) && ('y' == 121) && ('z' == 122) \
      && ('{' == 123) && ('|' == 124) && ('}' == 125) && ('~' == 126))
/* The character set is not based on ISO-646.  */
#error "gperf generated tables don't work with this execution character set. Please report a bug to <bug-gperf@gnu.org>."
#endif

struct word_type_gperf__src_file_descriptor_cpp_3 { const char* name; int (*action)(lua_State*); };
/* maximum key range = 24, duplicates = 0 */

class gperf__src_file_descriptor_cpp_3
{
private:
  static inline unsigned int hash (const char *str, size_t len);
public:
  static const struct word_type_gperf__src_file_descriptor_cpp_3 *in_word_set (const char *str, size_t len);
};

inline unsigned int
gperf__src_file_descriptor_cpp_3::hash (const char *str, size_t len)
{
  static const unsigned char asso_values[] =
    {
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27,  5, 27,
      27,  0, 10,  5, 27,  5, 27, 27, 27, 27,
      27, 27, 27, 27,  0,  0, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
      27, 27, 27, 27, 27, 27
    };
  unsigned int hval = len;

  switch (hval)
    {
      default:
        hval += asso_values[static_cast<unsigned char>(str[4])];
      /*FALLTHROUGH*/
      case 4:
      case 3:
        break;
    }
  return hval;
}

const struct word_type_gperf__src_file_descriptor_cpp_3 *
gperf__src_file_descriptor_cpp_3::in_word_set (const char *str, size_t len)
{
  enum
    {
      TOTAL_KEYWORDS = 8,
      MIN_WORD_LENGTH = 3,
      MAX_WORD_LENGTH = 16,
      MIN_HASH_VALUE = 3,
      MAX_HASH_VALUE = 26
    };

  static const struct word_type_gperf__src_file_descriptor_cpp_3 wordlist[] =
    {
      {"",{}}, {"",{}}, {"",{}},
      {"dup", 
            [](lua_State* L) -> int {
                lua_pushcfunction(L, file_descriptor_dup);
                return 1;
            }},
      {"",{}},
      {"close", 
            [](lua_State* L) -> int {
                lua_pushcfunction(L, file_descriptor_close);
                return 1;
            }},
      {"",{}},
      {"cap_set", 
            [](lua_State* L) -> int {
#if BOOST_OS_LINUX
                lua_pushcfunction(L, file_descriptor_cap_set);
#else
                lua_pushcfunction(L, throw_enosys);
#endif // BOOST_OS_LINUX
                return 1;
            }},
      {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"cap_get", 
            [](lua_State* L) -> int {
#if BOOST_OS_LINUX
                lua_pushcfunction(L, file_descriptor_cap_get);
#else
                lua_pushcfunction(L, throw_enosys);
#endif // BOOST_OS_LINUX
                return 1;
            }},
      {"",{}}, {"",{}}, {"",{}},
      {"cap_rights_limit", 
            [](lua_State* L) -> int {
#if BOOST_OS_BSD_FREE
                lua_pushcfunction(L, file_descriptor_cap_rights_limit);
#else
                lua_pushcfunction(L, throw_enosys);
#endif // BOOST_OS_BSD_FREE
                return 1;
            }},
      {"non_blocking",  file_descriptor_non_blocking_get},
      {"",{}}, {"",{}}, {"",{}},
      {"cap_ioctls_limit", 
            [](lua_State* L) -> int {
#if BOOST_OS_BSD_FREE
                lua_pushcfunction(L, file_descriptor_cap_ioctls_limit);
#else
                lua_pushcfunction(L, throw_enosys);
#endif // BOOST_OS_BSD_FREE
                return 1;
            }},
      {"",{}}, {"",{}}, {"",{}}, {"",{}},
      {"cap_fcntls_limit", 
            [](lua_State* L) -> int {
#if BOOST_OS_BSD_FREE
                lua_pushcfunction(L, file_descriptor_cap_fcntls_limit);
#else
                lua_pushcfunction(L, throw_enosys);
#endif // BOOST_OS_BSD_FREE
                return 1;
            }}
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      unsigned int key = hash (str, len);

      if (key <= MAX_HASH_VALUE)
        {
          const char *s = wordlist[key].name;

          if (*str == *s && !strcmp (str + 1, s + 1))
            return &wordlist[key];
        }
    }
  return 0;
}

} // namespace emilua::gperf::detail
// Copyright (c) 2022, 2024 Vinícius dos Santos Oliveira
// SPDX-License-Identifier: MIT OR BSL-1.0



namespace emilua {

char file_descriptor_mt_key;



static int file_descriptor_mt_index(lua_State* L)
{
    auto key = tostringview(L, 2);
    return  ::emilua::gperf::detail::value_or(::emilua::gperf::detail::gperf__src_file_descriptor_cpp_3::in_word_set((key).data(), (key).size()), [](lua_State* L) -> int {
            push(L, errc::bad_index, "index", 2);
            return lua_error(L);
        })(L);
}

inline int file_descriptor_non_blocking_set(lua_State* L)
{
    auto handle = static_cast<file_descriptor_handle*>(lua_touserdata(L, 1));
    if (*handle == INVALID_FILE_DESCRIPTOR) {
        push(L, std::errc::device_or_resource_busy);
        return lua_error(L);
    }
    if (!lua_isboolean(L, 3)) {
        push(L, std::errc::invalid_argument, "arg", 3);
        return lua_error(L);
    }

    bool value = lua_toboolean(L, 3);

#if BOOST_OS_WINDOWS
    return throw_enosys(L);
#else // BOOST_OS_WINDOWS
    int f = fcntl(*handle, F_GETFL, 0);

    // although not always documented, F_GETFL can fail
    if (f == -1) {
        push(L, std::error_code{errno, std::system_category()});
        return lua_error(L);
    }

    if ((f & O_NONBLOCK) == O_NONBLOCK) {
        if (!value) {
            if (fcntl(*handle, F_SETFL, f & ~O_NONBLOCK) == -1) {
                push(L, std::error_code{errno, std::system_category()});
                return lua_error(L);
            }
        }
    } else {
        if (value) {
            if (fcntl(*handle, F_SETFL, f | O_NONBLOCK) == -1) {
                push(L, std::error_code{errno, std::system_category()});
                return lua_error(L);
            }
        }
    }

    return 0;
#endif // BOOST_OS_WINDOWS
}

static int file_descriptor_mt_newindex(lua_State* L)
{
    auto key = tostringview(L, 2);
    if (key == "non_blocking") {
        return file_descriptor_non_blocking_set(L);
    } else {
        push(L, errc::bad_index, "index", 2);
        return lua_error(L);
    }
}

static int closed_file_descriptor_mt_index(lua_State* L)
{
    auto key = tostringview(L, 2);
    if (key == "close") {
        lua_pushcfunction(L, [](lua_State*) -> int { return 0; });
        return 1;
    } else {
        push(L, errc::bad_index, "index", 2);
        return lua_error(L);
    }
}

static int file_descriptor_mt_tostring(lua_State* L)
{
    auto& handle = *static_cast<file_descriptor_handle*>(lua_touserdata(L, 1));

    if (handle == INVALID_FILE_DESCRIPTOR) {
        push(L, std::errc::device_or_resource_busy);
        return lua_error(L);
    }

#if BOOST_OS_WINDOWS
    return throw_enosys(L);
#else // BOOST_OS_WINDOWS
    // Paranoia. Apparently the kernel side disagrees about what should be the
    // file descriptor's underlying type (cf. close_range(2)) so negative values
    // could be possible (very unlikely as EMFILE should still hinder them
    // anyway).
    if (handle < 0) [[unlikely]] {
        lua_pushfstring(L, "/dev/fd/%i", handle);
        return 1;
    }

    auto prefix = BOOST_HANA_STRING("/dev/fd/");
    constexpr auto max_digits = hana::second(hana::while_(
        [](auto s) { return hana::first(s) > hana::int_c<0>; },
        hana::make_pair(
            /*i=*/hana::int_c<std::numeric_limits<int>::max()>,
            /*max_digits=*/hana::int_c<0>),
        [](auto s) {
            return hana::make_pair(
                hana::first(s) / hana::int_c<10>,
                hana::second(s) + hana::int_c<1>);
        }
    ));

    std::array<char, hana::length(prefix).value + max_digits.value> buf;
    std::memcpy(buf.data(), prefix.c_str(), hana::length(prefix));
    auto s_size = std::to_chars(
        buf.data() + hana::length(prefix).value,
        buf.data() + buf.size(),
        handle).ptr - buf.data();

    lua_pushlstring(L, buf.data(), s_size);
    return 1;
#endif // BOOST_OS_WINDOWS
}

static int file_descriptor_mt_gc(lua_State* L)
{
    auto& handle = *static_cast<file_descriptor_handle*>(lua_touserdata(L, 1));
    if (handle == INVALID_FILE_DESCRIPTOR)
        return 0;

#if BOOST_OS_WINDOWS
    BOOL res = CloseHandle(handle);
#else // BOOST_OS_WINDOWS
    int res = close(handle);
#endif // BOOST_OS_WINDOWS
    boost::ignore_unused(res);
    return 0;
}

void init_file_descriptor(lua_State* L)
{
    lua_pushlightuserdata(L, &file_descriptor_mt_key);
    {
        lua_createtable(L, /*narr=*/0, /*nrec=*/5);

        lua_pushliteral(L, "__metatable");
        lua_pushliteral(L, "file_descriptor");
        lua_rawset(L, -3);

        lua_pushliteral(L, "__index");
        lua_pushcfunction(L, file_descriptor_mt_index);
        lua_rawset(L, -3);

        lua_pushliteral(L, "__newindex");
        lua_pushcfunction(L, file_descriptor_mt_newindex);
        lua_rawset(L, -3);

        lua_pushliteral(L, "__tostring");
        lua_pushcfunction(L, file_descriptor_mt_tostring);
        lua_rawset(L, -3);

        lua_pushliteral(L, "__gc");
        lua_pushcfunction(L, file_descriptor_mt_gc);
        lua_rawset(L, -3);
    }
    lua_rawset(L, LUA_REGISTRYINDEX);

    lua_pushlightuserdata(L, &closed_file_descriptor_mt_key);
    {
        lua_createtable(L, /*narr=*/0, /*nrec=*/2);

        lua_pushliteral(L, "__metatable");
        lua_pushliteral(L, "file_descriptor");
        lua_rawset(L, -3);

        lua_pushliteral(L, "__index");
        lua_pushcfunction(L, closed_file_descriptor_mt_index);
        lua_rawset(L, -3);
    }
    lua_rawset(L, LUA_REGISTRYINDEX);
}

} // namespace emilua
